#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
from taskinit import xmlpath
#from taskmanager import tm
import task_concat
def concat(vis=[''], concatvis='', freqtol='', dirtol='', respectname=False, timesort=False, copypointing=True, visweightscale=[], forcesingleephemfield=''):

        """Concatenate several visibility data sets.
           concat(vis=['src2.ms','ngc5921.ms'], concatvis='src2.ms')
               will concatenate 'ngc5921.ms' into 'src2.ms', and the original
	       src2.ms is lost

	   concat(vis=['src2.ms','ngc5921.ms'], concatvis='out.ms') 
               will concatenate 'ngc5921.ms' and 'src2.ms' into a file named 
               'out.ms'; the original 'ngc5921.ms' and 'src2.ms' are untouched.

	   concat(vis=['src2.ms','ngc5921.ms'], concatvis='out.ms', dirtol='0.5arcsec') 
               like the previous example but using a direction tolerance increased to
               0.5 arcsec. Fields whose directions differ by less than this limit are
               merged into one field with the name and direction from the 
               chronologically first input MS.

           concat(vis=['v1.ms','v2.ms'], concatvis = 'vall.ms')
              then
           concat(vis=['v3.ms','v4.ms'], concatvis = 'vall.ms')
             vall.ms will contains v1.ms+v2.ms+v3.ms+v4.ms

           Note: run flagmanager to save flags in the concatvis

        """
        if type(vis)==str: vis=[vis]
        if type(visweightscale)==float: visweightscale=[visweightscale]

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['concatvis'] = concatvis
        mytmp['freqtol'] = freqtol
        mytmp['dirtol'] = dirtol
        mytmp['respectname'] = respectname
        mytmp['timesort'] = timesort
        mytmp['copypointing'] = copypointing
        mytmp['visweightscale'] = visweightscale
        mytmp['forcesingleephemfield'] = forcesingleephemfield
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'concat.xml')

        casalog.origin('concat')
        if trec.has_key('concat') and casac.utils().verify(mytmp, trec['concat']) :
	    result = task_concat.concat(vis, concatvis, freqtol, dirtol, respectname, timesort, copypointing, visweightscale, forcesingleephemfield)

	else :
	  result = False
        return result
