#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
from taskinit import xmlpath
#from taskmanager import tm
import task_importgmrt
def importgmrt(fitsfile='', flagfile='', vis=''):

        """Convert a UVFITS file to a CASA visibility data set
        Convert a GMRT FITS file to a CASA visibility data set:

        Keyword arguments:
        fitsfile -- Name of input UV FITS file
                    default: none; example='3C273XC1.fits'
        flagfile -- List of files containing flagging information.
                    default: none; example='3c273XC1.flag'
                                   example=['3c273Cc1_1.flag','3c273Cc2_1.flag',']
        vis      -- Name of output visibility file (MS)
                    default: none; example: vis='3C273XC1.ms'
        async    -- Run asynchronously
                    default = false; do not run asychronously

	Note: Don't forget to flag autocorrections using
  	   taskname flagdata, autocorr = true

 
        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['fitsfile'] = fitsfile
        mytmp['flagfile'] = flagfile
        mytmp['vis'] = vis
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'importgmrt.xml')

        casalog.origin('importgmrt')
        if trec.has_key('importgmrt') and casac.utils().verify(mytmp, trec['importgmrt']) :
	    result = task_importgmrt.importgmrt(fitsfile, flagfile, vis)

	else :
	  result = False
        return result
