#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from casa_stack_manip import stack_frame_find
from odict import odict
from types import * 
from task_oldhanningsmooth import oldhanningsmooth
class oldhanningsmooth_cli_:
    __name__ = "oldhanningsmooth"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (oldhanningsmooth_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'vis':None, 'datacolumn':None, 'outputvis':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, vis=None, datacolumn=None, outputvis=None, ):

        """Hanning smooth frequency channel data to remove Gibbs ringing

	Detailed Description: 


    T H I S   T A S K   I S    D E P R E C A T E D
    I T   W I L L   B E   R E M O V E D   S O O N

    This function Hanning smoothes the frequency channels with
    a weighted running average. The weights are 0.5 for the central
    channel and 0.25 for each of the two adjacent channels. The first
    and last channels are flagged.
    Inclusion of a flagged value in an average causes that data value
    to be flagged.
    If an 'outputvis' filename is given, the task will copy the input file to the
    output file name first, including all columns that are present in the input MS.
    After that step it will smooth the column(s) as requested in the 'datacolumn' parameter.
    Alternatively, if no 'outputvis' is specified, oldhanningsmooth will work directly on the
    input visibility file.
    If the 'CORRECTED' data column is requested for an MS that does not contain this column,
    it will be filled from the 'DATA' column and then smoothed.

    WARNING: by default, all visibility columns will be smoothed. This will
             modify the DATA column of the output MS in order to make sure that
             later gaincal will work on the smoothed data, e.g. as part of self-cal.

    
	Arguments :
		vis:	Name of input visibility file (MS)
		   Default Value: 

		datacolumn:	the name of the MS column into which to write the smoothed data
		   Default Value: all
		   Allowed Values:
				corrected
				data
				all

		outputvis:	name of the output visibility file (MS)
		   Default Value: 

	Returns: void

	Example :



    Keyword arguments:
    vis -- Name of input visibility file (MS)
           default: none; example: vis='ngc5921.ms'
    datacolumn -- the name of the MS column to be Hanning smoothed
                  default='all'; example: datacolumn='corrected'
                  options: 'corrected', 'data', 'all'
    outputvis -- name of the output visibility file (MS)
                 default=none (write to the input MS); example: outputvis='ngc5921_src.ms'

    oldhanningsmooth(vis='ngc4852.ms', datacolumn='data', outputvis='ngc4852-hs.ms')


 
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	casa = self.__globals__['casa']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'oldhanningsmooth'
        self.__globals__['taskname'] = 'oldhanningsmooth'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['vis'] = vis = self.parameters['vis']
            myparams['datacolumn'] = datacolumn = self.parameters['datacolumn']
            myparams['outputvis'] = outputvis = self.parameters['outputvis']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['datacolumn'] = datacolumn
        mytmp['outputvis'] = outputvis
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.casac.utils().torecord(pathname+'oldhanningsmooth.xml')

        casalog.origin('oldhanningsmooth')
	try :
          #if not trec.has_key('oldhanningsmooth') or not casac.casac.utils().verify(mytmp, trec['oldhanningsmooth']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['oldhanningsmooth'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('oldhanningsmooth', 'oldhanningsmooth.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'oldhanningsmooth'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = oldhanningsmooth(vis, datacolumn, outputvis)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'oldhanningsmooth'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('oldhanningsmooth', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['vis']  = ''
        a['datacolumn']  = 'all'
        a['outputvis']  = ''


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='oldhanningsmooth', subkey=None):
        desc={'oldhanningsmooth': 'Hanning smooth frequency channel data to remove Gibbs ringing',
               'vis': 'Name of input visibility file (MS)',
               'datacolumn': 'the name of the MS column into which to write the smoothed data',
               'outputvis': 'name of the output visibility file (MS)',

              }

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['datacolumn']  = 'all'
        a['outputvis']  = ''

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if a.has_key(paramname) :
	      return a[paramname]
oldhanningsmooth_cli = oldhanningsmooth_cli_()
