#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_statwt2 import statwt2
from taskinit import casalog
from taskinit import xmlpath
class statwt2_pg_:
    __name__ = "statwt2"

    def __init__(self) :
       self.__bases__ = (statwt2_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,selectdata=None,field=None,spw=None,intent=None,array=None,observation=None,combine=None,timebin=None,slidetimebin=None,chanbin=None,minsamp=None,statalg=None,fence=None,center=None,lside=None,zscore=None,maxiter=None,excludechans=None,wtrange=None,flagbackup=None,preview=None,datacolumn=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'statwt2'
        myf['taskname'] = 'statwt2'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['selectdata'] = selectdata = myf['selectdata']
            myparams['field'] = field = myf['field']
            myparams['spw'] = spw = myf['spw']
            myparams['intent'] = intent = myf['intent']
            myparams['array'] = array = myf['array']
            myparams['observation'] = observation = myf['observation']
            myparams['combine'] = combine = myf['combine']
            myparams['timebin'] = timebin = myf['timebin']
            myparams['slidetimebin'] = slidetimebin = myf['slidetimebin']
            myparams['chanbin'] = chanbin = myf['chanbin']
            myparams['minsamp'] = minsamp = myf['minsamp']
            myparams['statalg'] = statalg = myf['statalg']
            myparams['fence'] = fence = myf['fence']
            myparams['center'] = center = myf['center']
            myparams['lside'] = lside = myf['lside']
            myparams['zscore'] = zscore = myf['zscore']
            myparams['maxiter'] = maxiter = myf['maxiter']
            myparams['excludechans'] = excludechans = myf['excludechans']
            myparams['wtrange'] = wtrange = myf['wtrange']
            myparams['flagbackup'] = flagbackup = myf['flagbackup']
            myparams['preview'] = preview = myf['preview']
            myparams['datacolumn'] = datacolumn = myf['datacolumn']

        if type(wtrange)==float: wtrange=[wtrange]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['selectdata'] = selectdata
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['intent'] = intent
        mytmp['array'] = array
        mytmp['observation'] = observation
        mytmp['combine'] = combine
        mytmp['timebin'] = timebin
        mytmp['slidetimebin'] = slidetimebin
        mytmp['chanbin'] = chanbin
        mytmp['minsamp'] = minsamp
        mytmp['statalg'] = statalg
        mytmp['fence'] = fence
        mytmp['center'] = center
        mytmp['lside'] = lside
        mytmp['zscore'] = zscore
        mytmp['maxiter'] = maxiter
        mytmp['excludechans'] = excludechans
        mytmp['wtrange'] = wtrange
        mytmp['flagbackup'] = flagbackup
        mytmp['preview'] = preview
        mytmp['datacolumn'] = datacolumn
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'statwt2.xml')

        casalog.origin('statwt2')
        if not trec.has_key('statwt2') or not casac.utils().verify(mytmp, trec['statwt2']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: statwt2           #####')
          casalog.post('')
          result = statwt2(vis, selectdata, field, spw, intent, array, observation, combine, timebin, slidetimebin, chanbin, minsamp, statalg, fence, center, lside, zscore, maxiter, excludechans, wtrange, flagbackup, preview, datacolumn)
          casalog.post('')
          casalog.post('##### End Task: statwt2           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('statwt2', 'statwt2.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'statwt2'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('statwt2', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['vis']  = ''
        a['selectdata']  = True
        a['combine']  = ''
        a['timebin']  = 1
        a['slidetimebin']  = False
        a['chanbin']  = 'spw'
        a['minsamp']  = 2
        a['statalg']  = 'classic'
        a['excludechans']  = ''
        a['wtrange']  = []
        a['flagbackup']  = True
        a['preview']  = False
        a['datacolumn']  = 'corrected'

        a['selectdata'] = {
                    0:odict([{'value':True}, {'field':""}, {'spw':""}, {'observation':""}, {'intent':""}, {'array':""}])}
        a['statalg'] = {
                    0:{'value':'classic'}, 
                    1:odict([{'value':'hinges-fences'}, {'fence':-1}]), 
                    2:odict([{'value':'fit-half'}, {'center':'mean'}, {'lside':True}]), 
                    3:odict([{'value':'chauvenet'}, {'zscore':-1}, {'maxiter':-1}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['selectdata']  = True
        a['field']  = ''
        a['spw']  = ''
        a['intent']  = ''
        a['array']  = ''
        a['observation']  = ''
        a['combine']  = ''
        a['timebin']  = 1
        a['slidetimebin']  = False
        a['chanbin']  = 'spw'
        a['minsamp']  = 2
        a['statalg']  = 'classic'
        a['fence']  = -1
        a['center']  = 'mean'
        a['lside']  = True
        a['zscore']  = -1
        a['maxiter']  = -1
        a['excludechans']  = ''
        a['wtrange']  = []
        a['flagbackup']  = True
        a['preview']  = False
        a['datacolumn']  = 'corrected'

        if a.has_key(paramname) :
	      return a[paramname]
statwt2_pg = statwt2_pg_()
